<?php
/*	Modul: alkisfkt.php

	ALKIS-Buchauskunft, Kommunales Rechenzentrum Minden-Ravensberg/Lippe (Lemgo).
	Functions

	Version:
	2016-02-24 Version fuer norGIS-ALKIS-Import, "function linkgml" raus. Case-Entschlüsselung raus.
	2016-03-03 Hinweis auf Datenfehler wenn "ax_person" fehlt in function "eigentuemer"
	2016-03-14 Kleine Korrekturen
	2016-11-29 Gemeinsam genutzte Datenbanken ermöglichen (Filter Gemeinde)
	2017-06-08 gestreifte Tabelle, Feinkorrekturen
	2017-10-17 Deutsches Datumsformat für Geburtsdatum der Person
	2017-11-03 neue function werteliste()
	2017-12-20 Default Anzeigewert "Eigentümer" im Link für leere Eigentümerart, Jüngste Adresse zur Person verwenden.
*/

function footer($gmlid, $link, $append) {
	// Einen Seitenfuss ausgeben.
	// Die Parameter &gkz= und &gmlid= kommen in allen Modulen einheitlich vor
	// Den URL-Parameter "&showkey=j/n" umschalten lassen.
	// $append wird angehaengt wenn gefuellt. Anwendung: &eig=j bei FS-NW, &ltyp=m/p/o bei Lage
	global $gkz, $showkey, $hilfeurl, $auth;

	// S c r e e n - Foot
	echo "\n<div class='confbereich noprint'>"
	."\n\t<table class='outer'>\n\t<tr>";

	// Spalte 1: Info Benutzerkennung
	if ($auth == "mapbender") {
		$customer=$_SESSION["mb_user_name"];
		echo "\n\t\t<td title='Info'><i>Benutzer:&nbsp;".$customer."</i></td>";
	} else {
		echo "\n\t\t<td>&nbsp;</td>";
	}

	// Spalte 2: Umschalter
	echo "\n\t\t<td title='Konfiguration'>";
		$mylink ="\n\t\t\t<a class='keyswitch' href='".$link."gkz=".$gkz."&amp;gmlid=".$gmlid.$append;

		if ($showkey) { // Umschalten Schlüssel ein/aus
			echo $mylink."&amp;showkey=n' title='Verschl&uuml;sselungen ausblenden'>Schl&uuml;ssel aus</a>";
		} else {
			echo $mylink."&amp;showkey=j' title='Verschl&uuml;sselungen anzeigen'>Schl&uuml;ssel ein</a>";
		}
	echo "\n\t\t</td>";

	// Spalte 3
	echo "\n\t\t<td title='Hilfe'>"
		."\n\t\t\t<p class='nwlink'>\n\t\t\t\t<a target='_blank' href='".$hilfeurl."' title='Dokumentation'>Hilfe zur ALKIS-Auskunft</a>\n\t\t\t</p>\n\t\t</td>"
		."\n\t</tr>\n\t</table>"
	."\n</div>\n";

	// P r i n t - Foot
	if ($auth == "mapbender") {
	//	$customer=$_SESSION["mb_user_name"];
		echo "\n<p class='onlyprint'><i>Mapbender-Benutzer:&nbsp;".$customer."</i></p>";
	}

	return 0;
}

function ber_bs_hinw($gmls, $gmlf) {
	// Berechtigte Buchungs-Stellen - Hinweis.
	// Unter dem Grundbuch-Link den Hinweis auf "berechtigte Buchungssstellen" anzeigen und einen Umschalter.
	global $gkz, $debug, $showkey, $berbu, $eig;

	// Buchungstelle dienend <(Recht)an< Buchungstelle herrschend
	$sql ="SELECT count(sh.gml_id) AS anz, sh.buchungsart, a.v "
	."FROM ax_buchungsstelle sd JOIN ax_buchungsstelle sh ON sd.gml_id=ANY(sh.an) " 
	."LEFT JOIN alkis_wertearten a ON sh.buchungsart=cast(a.k AS integer) " 
	."WHERE sd.gml_id= $1 AND sh.endet IS NULL AND sd.endet IS NULL AND a.element='ax_buchungsstelle' and a.bezeichnung='buchungsart' "
	."GROUP BY sh.buchungsart, a.v;";

	$v = array($gmls); // GML dienende Buchungs-Stelle
	$resan = pg_prepare("", $sql);
	$resan = pg_execute("", $v);
	if (!$resan) {
		echo "\n<p class='err'>Fehler bei 'berechtigte Buchungsstellen'.</p>";
		if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = gml_id = '".$gmls."'</p>";}
	}
	$zeile=0; // Vesrchiedene Arten
	$cnt=0; // Summe der Buchugen
	while($rowan = pg_fetch_array($resan)) {
		$anz=$rowan["anz"];

		// Einleitung
		if ($zeile == 0) { // vor. 1. Zeile
			// Diese Hinweise sollen mit gedruckt werden. Also KEIN "noprint"!
			echo "\n\t\t<br>\n\t\t<p class='nwlink' title='Andere Grundst&uuml;cke mit Rechten an diesem.'>\n\t\t\tBerechtigte Buchungen ";
			if ($berbu=="j") { // wechselndes Symbol
				echo "<img src='ico/Grundbuch_zu.png' width='16' height='16' alt=''>";
			} else {
				echo "<img src='ico/Grundbuch.png' width='16' height='16' alt=''>";
			}
			echo "\n\t\t\t<b>";
		}

		// Eine Zeile je Buchungs-Typ
		echo "<br>".$anz." ".htmlentities($rowan["v"], ENT_QUOTES, "UTF-8");
		if ($showkey) {echo " <span class='key'>(".$rowan["buchungsart"].")</span>";}
		$zeile++;
		$cnt = $cnt + $anz;
	} // Ende Result
	pg_free_result($resan);

	// Ergebnis
	if ($zeile == 0) { // kein Schleifen-Durchlauf
		echo "\n\t<p class='nwlink' title='Kein anderes Grundst&uuml;ck hat ein Recht an diesem.'>Keine berechtigte Buchung</p>";
	} else { // Schleife wurde durchlaufen,
		echo "</b>\n\t\t</p>";

		// Umschalter nicht drucken
		echo "\n\t\t<p class='nwlink noprint'>"
		."\n\t\t\t<a href='".$_SERVER['PHP_SELF']."?gkz=".$gkz."&amp;gmlid=".$gmlf."&eig=".$eig; // GML Flurstück
		if ($showkey) {echo "&amp;showkey=j";}
		// Der FS-Nachweis ruft sich selbst mit geaendertem Parameter auf.
		if ($berbu=="j") {
			echo "&amp;berbu=n' title='ohne berechtigte Buchungen'>nicht Anzeigen"; // Position: Top
		} else {
			echo "&amp;berbu=j#berbu' title='mit berechtigten Buchungen'>Anzeigen"; // Positionierung auf Marke #berbu
		}
		echo "</a>\n\t\t</p>";
	}
	return $cnt; // Funktionswert = Anzahl der berechtigten Buchungen
}

function ber_bs_anz($gmls, $eig) {
	// Berechtigte Buchungsstellen (+ Blätter, Eigentümer) anzeigen innerhalb eines FS-Nachw.
	// Im FS-Nachweis werden auch die berechtigten Grundbücher mit ihren Eigentümern angezeigt.
	// Also z.B. zu einem "fiktiven Blatt" auch die Grundbuücher mit dem "Wohnungs-/Teileigentum"
	global $gkz, $debug, $showkey, $idanzeige;

	// Herrschende (berechtigte) Buchungsstellen ausgeben - Beginn
	// sd=Buchungstelle herrschend >(Recht)an> sd=Buchungstelle dienend >istBestandteilVon> BLATT -> Bezirk
	$sql="SELECT sd.gml_id AS s_gml, "  // Buchungs-Stelle dienend
	."sh.buchungsart, sh.laufendenummer as lfd, sh.zaehler, sh.nenner, sh.nummerimaufteilungsplan as nrpl, sh.beschreibungdessondereigentums as sond, " // Buchungs-Stelle herrschend
	."b.gml_id AS g_gml, b.bezirk, b.buchungsblattnummermitbuchstabenerweiterung as blatt, b.blattart, z.bezeichnung, a.v AS bart, w.v AS blattartv "
	."FROM ax_buchungsstelle sd "
	."JOIN ax_buchungsstelle sh ON sd.gml_id=ANY(sh.an) "
	."JOIN ax_buchungsblatt b ON b.gml_id=sh.istbestandteilvon "
	."LEFT JOIN ax_buchungsblattbezirk z ON z.land=b.land AND z.bezirk=b.bezirk "
	."LEFT JOIN alkis_wertearten a ON sh.buchungsart=cast(a.k AS integer) AND a.element='ax_buchungsstelle' and a.bezeichnung='buchungsart' " // entschlüsseln Buchungsart
	."LEFT JOIN alkis_wertearten w ON b.blattart=w.k AND w.element='ax_buchungsblatt' and w.bezeichnung='blattart' " // entschlüsseln Blatt-Art
	."WHERE sd.gml_id= $1 AND sd.endet IS NULL AND sh.endet IS NULL AND b.endet IS NULL AND z.endet IS NULL "
	."ORDER BY b.bezirk, b.buchungsblattnummermitbuchstabenerweiterung;";

	$v = array($gmls); // id dienende Buchungsstelle
	$resber = pg_prepare("", $sql);
	$resber = pg_execute("", $v);
	if (!$resber) {
		echo "\n<p class='err'>Fehler bei 'berechtigte Buchungsstellen'.</p>";
		if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = gml_id = '".$gmls."'</p>";}
	}

	$an=0;
	while($rowan = pg_fetch_array($resber)) {
		$beznam=$rowan["bezeichnung"];
		$bart=$rowan["bart"]; // Buchungsart
		$blattkeyber=$rowan["blattart"];  // Schluessel von Blatt-Art des berechtigten GB
		$blattartber=$rowan["blattartv"]; // Wert von Blatt-Art des berechtigten GB
		$nrpl=$rowan["nrpl"]; // Nummer im Aufteilungsplan
		$sond=$rowan["sond"]; // Beschreibung des Sondereigentums

		echo "\n<table class='outer'>" // \n<hr>
		."\n<tr>" // 1 row only
			."\n<td>"; // outer linke Spalte - Daten
				// Rahmen mit Kennzeichen GB
				if ($blattkeyber == 1000) {
					echo "\n\t<table class='kennzgb' title='Bestandskennzeichen'>";
				} else {
					echo "\n\t<table class='kennzgbf' title='Bestandskennzeichen'>"; // dotted
				}
				echo "\n\t<tr>"
					."\n\t\t<td class='head'>Bezirk</td>"
					."\n\t\t<td class='head'>".$blattartber."</td>"
					."\n\t\t<td class='head'>Lfd-Nr,</td>"
					."\n\t\t<td class='head'>Buchungsart</td>"
				."\n\t</tr>";
				echo "\n\t<tr>"
					."\n\t\t<td title='Grundbuchbezirk'>";
					if ($showkey) {echo "<span class='key'>".$rowan["bezirk"]."</span><br>";}
					echo $beznam."</td>"
					."\n\t\t<td title='Grundbuch-Blatt'><span class='wichtig'>".$rowan["blatt"]."</span></td>"
					."\n\t\t<td title='Bestandsverzeichnis-Nummer (BVNR, Grundst&uuml;ck)'>".$rowan["lfd"]."</td>"
					."\n\t\t<td title='Buchungsart'>";
						if ($showkey) {echo "<span class='key'>".$rowan["buchungsart"]."</span><br>";}
						echo $rowan["bart"]
					."</td>"
				."\n\t</tr>"
				."\n\t</table>";
				if ($rowan["zaehler"] <> "") {
					echo "\n\t<p class='ant'>".$rowan["zaehler"]."/".$rowan["nenner"]."&nbsp;Anteil am Flurst&uuml;ck</p>";
				}
			echo "\n</td>";

			echo "\n<td>"; // outer rechte Spalte
				if ($idanzeige) {
					linkgml($gkz, $rowan["s_gml"], "Buchungsstelle", "ax_buchungsstelle");
					echo "<br>";
					linkgml($gkz, $rowan["g_gml"], "Buchungsblatt", "");
				}
				echo "\n\t<br>"
				."\n\t<p class='nwlink noprint'>";
					if ($showkey) {echo "<span class='key'>".$blattkeyber."</span> ";}
					echo "\n\t\t<a href='alkisbestnw.php?gkz=".$gkz."&amp;gmlid=".$rowan["g_gml"];
						if ($idanzeige) {echo "&amp;id=j";}
						if ($showkey)   {echo "&amp;showkey=j";}
						echo "' title='Grundbuchnachweis mit Eigent&uuml;merangabe'>".$blattartber
						." <img src='ico/GBBlatt_link.png' width='16' height='16' alt=''>"
					."</a>";
				echo "\n\t</p>"
			."\n\t</td>"
		."\n</tr>"
		."\n</table>";

		if ($blattkeyber != 1000) {
			echo "\n<p>Blattart: ".$blattartber." (".$blattkeyber.").<br>"; 
		}

		if ($nrpl != "") {
			echo "\n<p class='nrap' title='Nummer im Aufteilungsplan'>Nummer <span class='wichtig'>".$nrpl."</span> im Aufteilungsplan.</p>";
		}

		if ($sond != "") {
			echo "\n<p class='sond' title='Sondereigentum'>Verbunden mit dem Sondereigentum<br>".$sond."</p>";
		}

		if ($eig == "j") {
			$n = eigentuemer($rowan["g_gml"], true, ""); // mit Adresse
		}
		$an++;	
	}
	pg_free_result($resber);
	return;
}


function kurz_namnr($lang) {
	// Namensnummer kürzen. Nicht benötigte Stufen der Dezimalklassifikation abschneiden
	$kurz=str_replace(".00","",$lang); // leere Stufen (nur am Ende)
	$kurz=str_replace("0000","",$kurz); // ganz leer (am Anfang)
	$kurz=ltrim($kurz, "0"); // fuehrende Nullen am Anfang
	$kurz=str_replace(".0",".",$kurz); // fuehrende Null jeder Stufe
	$kurz=rtrim($kurz); // Leerzeichen hinten
	// echo "/n<p class='dbg'> lang='".$lang."'</p>/n<p class='dbg'> kurz='".$kurz."'</p>";
	return $kurz;
}

function bnw_fsdaten($con, $lfdnr, $gml_bs, $ba, $anteil, $bvnraus, $bartkey, $bartstory) {
/*	Bestandsnachweis - Flurstuecksdaten
	Die Tabellenzeilen mit den Flurstuecksdaten zu einer Buchungsstelle im Bestandsnachweis ausgeben.
	Die Funktion wird je einmal aufgerufen für die Buchungen direkt auf dem GB (Normalfall).
	Weiterere Aufrufe ggf. bei Erbbaurecht für die mit "an" verknuepften Buchungsstellen.
	Table-Tag und Tabellenkopf werden im aufrufenden Programm ausgegeben. */
	global $debug, $gkz, $showkey, $filtkreis, $filtgem, $trclass; // $zpaar

	// F L U R S T U E C K
	$sql="SELECT g.gemarkungsnummer, g.bezeichnung, f.gml_id, f.flurnummer, f.zaehler, f.nenner, f.regierungsbezirk, f.kreis, f.gemeinde, f.amtlicheflaeche 
	FROM ax_flurstueck f JOIN ax_buchungsstelle s ON f.istgebucht=s.gml_id 
	LEFT JOIN ax_gemarkung g ON f.land=g.land AND f.gemarkungsnummer=g.gemarkungsnummer 
	WHERE f.endet IS NULL AND s.endet IS NULL AND g.endet IS NULL AND s.gml_id= $1 ";
	if ($filtgem == '' ) { // ungefiltert
		$v=array($gml_bs);
	} else {
		$sql.="AND f.kreis = $2 AND f.gemeinde = $3 "; // Zuständiges Gebiet
		$v=array($gml_bs, $filtkreis, $filtgem);
	}
	$sql.="ORDER BY f.gemarkungsnummer, f.flurnummer, f.zaehler, f.nenner;";
	$resf = pg_prepare("", $sql);
	$resf = pg_execute("", $v);
	if (!$resf) {echo "\n<p class='err'>Fehler bei Flurst&uuml;ck</p>";}

	if($bvnraus) { // nur bei direkten Buchungen die lfdNr ausgeben
		$bvnr=str_pad($lfdnr, 4, "0", STR_PAD_LEFT);
	} else {
		$bvnr="";
	}
	$altbvnr="";
	$j=0;
	while($rowf = pg_fetch_array($resf)) {
		$flur=str_pad($rowf["flurnummer"], 3, "0", STR_PAD_LEFT);
		$fskenn=$rowf["zaehler"];
		if ($rowf["nenner"] != "") { // Bruch
			$fskenn.="/".$rowf["nenner"];
		}
		$flae=number_format($rowf["amtlicheflaeche"],0,",",".") . " m&#178;";

		echo "\n<tr class='".$trclass."'>"; // eine Zeile je Flurstueck
			// Sp. 1-3 der Tab. aus Buchungsstelle, nicht aus FS
			if($bvnr == $altbvnr) { // gleiches Grundstueck, leer lassen
				echo "\n\t<td>&nbsp;</td>"
				."\n\t<td>&nbsp;</td>"
				."\n\t<td>&nbsp;</td>";
			} else { // Sprungmarke, BVNR
				echo "\n\t<td id='bvnr".$bvnr."'>"; // Sprungmarke
				//	echo "\n\t\t<a id='bvnr".$bvnr."'></a>";
					echo "<span class='wichtig'>".$bvnr."</span>"
				."\n\t</td>";

				echo "\n\t<td title ='".$bartstory."'>"; // Buchungsart 
					if ($showkey) {echo "<span class='key'>".$bartkey."</span>&nbsp;";} // Schluessel
					echo $ba; // entschluesselt
				echo "</td>"
				."\n\t<td>&nbsp;</td>"; // Anteil
				$altbvnr=$bvnr;
			}

			// Sp. 4-7 aus Flurstueck
			echo "\n\t<td>";
			if ($showkey) {echo "<span class='key'>".$rowf["gemarkungsnummer"]."</span> ";}
			echo $rowf["bezeichnung"]."</td>"
			."\n\t<td>".$flur."</td>"
			."\n\t<td class='fsnr'><span class='wichtig'>".$fskenn."</span>"
			."</td>"
			."\n\t<td class='flag'>".$flae."</td>"; // "width" hier (flaG) erweiterbar, weil in andere Zeile die Buchungsart steht 

			echo "\n\t<td>\n\t\t<p class='nwlink noprint'>"
				."\n\t\t\t<a href='alkisfsnw.php?gkz=".$gkz."&amp;gmlid=".$rowf["gml_id"]."&amp;eig=n";
					if ($showkey)   {echo "&amp;showkey=j";}
					echo "' title='Flurst&uuml;cksnachweis'>Flurst&uuml;ck "
					."<img src='ico/Flurstueck_Link.png' width='16' height='16' alt=''>"
				."</a>"
			."\n\t\t</p>"
		."\n\t</td>"
		."\n</tr>";

		$j++;
	} // Ende Loop Flurstueck
	pg_free_result($resf);
	return $j;
}

function eigentuemer($gmlid, $mitadresse, $lnkclass) {
	// Tabelle mit Eigentuemerdaten zu einem Grundbuchblatt ausgeben
	// Sp.1 = Namennummer, Sp. 2 = Name / Adresse, Sp. 3 = Link
	// Parameter:
	//	$gmlid = ID GB-Blattes
	//	$mitadresse = Option (true/false) ob die Adresszeile ausgegeben werden soll
	// Return = Anzahl Namensnummern

	// Schleife 1: N a m e n s n u m m e r
	// Beziehung: ax_namensnummer >istBestandteilVon> ax_buchungsblatt
	global $debug, $gkz, $showkey;

	// Link über Java-Class? (Ja in alkisinlayausk.php, sonst normal)
	if ($lnkclass == "") {
		$lnkvor = "";
		$lnknach = "";
	} else {
		$lnkvor  = "javascript:".$lnkclass."(\"";
		$lnknach = "\")";
	} // Beispiel-Link href='javascript:imFenster(\"alkislage.php?gkz= ... ."\")'>xxx ";

	$sqln="SELECT n.gml_id, n.laufendenummernachdin1421 AS lfd, n.zaehler, n.nenner, n.artderrechtsgemeinschaft AS adr, n.beschriebderrechtsgemeinschaft as beschr, n.eigentuemerart, n.anlass, n.benennt, wn.v AS adrv, we.v AS eiartv "
	."FROM ax_namensnummer n "
	."LEFT JOIN alkis_wertearten wn ON cast(n.artderrechtsgemeinschaft AS character varying)=wn.k AND wn.element='ax_namensnummer' AND wn.bezeichnung='artderrechtsgemeinschaft' "
	."LEFT JOIN alkis_wertearten we ON cast(n.eigentuemerart AS character varying)=we.k AND we.element='ax_namensnummer' AND we.bezeichnung='eigentuemerart' "
	."WHERE n.istbestandteilvon= $1 AND n.endet IS NULL ORDER BY n.laufendenummernachdin1421;";

	$v = array($gmlid); // 16 Stellen bei Relationen
	$resn = pg_prepare("", $sqln);
	$resn = pg_execute("", $v);

	if (!$resn) {
		echo "\n<p class='err'>Fehler bei Eigent&uuml;mer</p>";
		// kein Fehler bei Blattarten > 1000
		//if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".$sqln."<br>$1=gml= '".$gmlid."'</p>";}
	}

	$n=0; // Z.NamNum.
	while($rown = pg_fetch_array($resn)) {
		if($n == 0) { // Die Überschrift nur, wenn auch ein Inhalt folgt
			echo "\n\n<h3><img src='ico/Eigentuemer_2.png' width='16' height='16' alt=''> Angaben zum Eigentum</h3>"
			."\n<table class='eig'>";
		}
		$gmlnn=$rown["gml_id"];
		$namnum=kurz_namnr($rown["lfd"]);
		$rechtsg=$rown["adr"];
		echo "\n<tr>"
			."\n\t<td class='nanu' title='Namens-Nummer'>\n\t\t<p>" // Sp. 1
				.$namnum."&nbsp;" // VOR die Tabelle: "Eigentümer"
			."</p>\n\t</td>"
			. "\n\t<td>"; // Sp. 2
			if ($rechtsg != "" ) {
				if ($rechtsg == 9999) { // sonstiges
					echo "\n\t\t<p class='zus' title='Beschrieb der Rechtsgemeinschaft'>".htmlentities($rown["beschr"], ENT_QUOTES, "UTF-8")."</p>";
				} else {
					echo "\n\t\t<p class='zus' title='Art der Rechtsgemeinschaft'>".htmlentities($rown["adrv"], ENT_QUOTES, "UTF-8")."</p>";
				}
			}
			//if ($rown["anlass"] > 0 ) {echo "<p>Anlass=".$rown["anlass"]."</p>";} // TEST:

			// Schleife Ebene 2: andere Namensnummern
			// Beziehung   ax_namensnummer >bestehtAusRechtsverhaeltnissenZu>  ax_namensnummer 

			// Die Relation 'Namensnummer' besteht aus Rechtsverhältnissen zu 'Namensnummer' sagt aus, 
			// dass mehrere Namensnummern zu einer Rechtsgemeinschaft gehören können. 
			// Die Rechtsgemeinschaft selbst steht unter einer eigenen AX_Namensnummer, 
			// die zu allen Namensnummern der Rechtsgemeinschaft eine Relation besitzt.

		// Schleife 2: P e r s o n
		// Beziehung: ax_person  <benennt<  ax_namensnummer
		$sqlp="SELECT gml_id, nachnameoderfirma, vorname, geburtsname, to_char(cast(geburtsdatum AS date),'DD.MM.YYYY') AS geburtsdatum, namensbestandteil, akademischergrad "
		."FROM ax_person WHERE gml_id= $1 AND endet IS NULL;";
		$gmlpers=$rown["benennt"];
		$v = array($gmlpers); // gml_id von ax_person
		$resp = pg_prepare("", $sqlp);
		$resp = pg_execute("", $v);
		if (!$resp) {
			echo "\n\t<p class='err'>Fehler bei Person</p>";
			if ($debug > 2) {echo "\n<p class='err'>SQL=<br>".$sqlp."<br>$1=gml= '".$gmlpers."'</p>";}
		}

		$i=0; // cnt Person
		while($rowp = pg_fetch_array($resp)) { // Schleife weglassen? nn >benennt> Person ist KEIN Array!
			$diePerson=""; //++ Anrede?
			if ($rowp["akademischergrad"] <> "") {$diePerson=$rowp["akademischergrad"]." ";}
			$diePerson.=$rowp["nachnameoderfirma"];
			if ($rowp["vorname"] <> "") {$diePerson.=", ".$rowp["vorname"];}
			if ($rowp["namensbestandteil"] <> "") {$diePerson.=". ".$rowp["namensbestandteil"];}
			if ($rowp["geburtsdatum"] <> "") {$diePerson.=", geb. ".$rowp["geburtsdatum"];}
			if ($rowp["geburtsname"] <> "") {$diePerson.=", geb. ".$rowp["geburtsname"];}
			$diePerson=htmlentities($diePerson, ENT_QUOTES, "UTF-8"); // Umlaute

			if ($i > 0) { // Spalte 1 enthält die Namensnummer, nur in Zeile 0
				echo "\n<tr>\n\t<td>&nbsp;</td>\n\t<td>";
			}
			// Spalte 2 = Angaben
			$eiartkey=$rown["eigentuemerart"]; // Key
			$eiart=$rown["eiartv"]; // Value
			echo "\n\t\t<p class='geig' title='Eigent&uuml;merart: ".$eiart."'>".$diePerson."</p>\n\t</td>";

			// Spalte 3 = Link
			echo "\n\t<td>\n\t\t<p class='nwlink noprint'>";
				if ($showkey AND $eiartkey != '') { // oft leer
					echo "<span class='key' title='Eigent&uuml;merart'>".$eiartkey."</span> ";
				}
				echo "\n\t\t\t<a href='".$lnkvor."alkisnamstruk.php?gkz=".$gkz."&amp;gmlid=".$rowp[0];
				if ($showkey) {echo "&amp;showkey=j";}
				if ($eiartkey == "") {$eiart="Eigent&uuml;mer" ;} // Default. Ersatz-Text, wenn nicht gefüllt
				echo $lnknach."' title='vollst&auml;ndiger Name und Adresse eines Eigent&uuml;mers'>".$eiart
				." <img src='ico/Eigentuemer.png' width='16' height='16' alt=''></a>\n\t\t</p>"
			."\n\t</td>\n</tr>";

			if ($mitadresse) {
				// Schleife 3:  A d r e s s e  (OPTIONAL)
				$sqla ="SELECT a.gml_id, a.ort_post, a.postleitzahlpostzustellung AS plz, a.strasse, a.hausnummer, a.bestimmungsland "
				."FROM ax_anschrift a JOIN ax_person p ON a.gml_id=ANY(p.hat) WHERE p.gml_id= $1 AND a.endet IS NULL AND p.endet IS NULL ORDER BY a.beginnt DESC LIMIT 2;";
				$gmlp=$rowp["gml_id"]; // Person
				$v = array($gmlp);
				$resa = pg_prepare("", $sqla);
				$resa = pg_execute("", $v);

				if (!$resa) {
					echo "\n\t<p class='err'>Fehler bei Adressen</p>";
					if ($debug > 2) {echo "\n<p class='err'>SQL=<br>".$sqla."<br>$1=gml= '".$gmlp."'</p>";}
				}
				$j=0;
				while($rowa = pg_fetch_array($resa)) {
					$j++;
					if ($j == 1) { // erste ("jüngste") Adresse anzeigen
						$gmla=$rowa["gml_id"];
						$plz=$rowa["plz"]; // integer
						if($plz == 0) {
							$plz="";
						} else {
							$plz=str_pad($plz, 5, "0", STR_PAD_LEFT);
						}
						$ort=htmlentities($rowa["ort_post"], ENT_QUOTES, "UTF-8");
						$str=htmlentities($rowa["strasse"], ENT_QUOTES, "UTF-8");
						$hsnr=$rowa["hausnummer"];
						$land=htmlentities($rowa["bestimmungsland"], ENT_QUOTES, "UTF-8");

						echo "\n<tr>\n\t<td>&nbsp;</td>"; //Sp. 1
						echo "\n\t<td><p class='gadr'>"; //Sp. 2
						if ($str.$hsnr != "") {echo $str." ".$hsnr."<br>";}
						if ($plz.$ort != "") {echo $plz." ".$ort;}
						if ($land != "" and $land != "DEUTSCHLAND") {echo ", ".$land;}
						echo "</p></td>\n\t<td>"; // Sp. 3
						echo "&nbsp;</td>\n</tr>";
					} else { // manchmal doppelte Angaben
						echo "\n<tr>\n\t<td>&nbsp;</td>\n\t<td><p class='dbg' title='Siehe Auskunft zur Person'>weitere Adresse</p></td>\n\t<td>&nbsp;</td>\n</tr>";
					}
				}
				pg_free_result($resa);
			}
			// 'keine Adresse' kann vorkommen, z.B. "Deutsche Telekom AG"
			$i++; // cnt Person

			// Anteil als eigene Tab-Zeile:
			$zaehler=$rown["zaehler"];
			if ($zaehler != "") {
				$zaehler=str_replace(".", ",", $zaehler); // Dezimal-KOMMA wenn dem Notar der Bruch nicht reicht
				$nenner=str_replace(".", ",", $rown["nenner"]);
				$comnt="Anteil der Berechtigten in Bruchteilen (Par. 47 GBO) an einem gemeinschaftlichen Eigentum (Grundst&uuml;ck oder Recht).";
				echo "\n<tr>\n\t<td>&nbsp;</td>" // Sp. 1
				."\n\t<td><p class='avh' title='".$comnt."'>".$zaehler."/".$nenner." Anteil</p></td>"
				."\n\t<td>&nbsp;</td>\n</tr>"; // Sp. 3
			}
		} // End Loop Person
		if ($i == 0) { // Keine Person. Das kommt vor hinter der Zeile "Erbengemeinschaft" und ist dann KEIN Fehler
			if ($rechtsg != 9999) {
				echo "\n<p class='err'>(Die Person mit der ID '".$gmlpers."' fehlt im Datenbestand)</p>";
			} else {
				if ($debug > 1) { // nur bei Entwicklung
					echo "\n\t\t<p class='dbg'>Rechtsgemeinschaft = '".$rechtsg."'</p>";
				}
			}
			echo "</td>\n\t<td>&nbsp;</td>\n</tr>";
		}
		$n++; // cnt NamNum
	} // End Loop NamNum
	if($n > 0) {
		echo "\n</table>";
	} else { // $n == 0, bei "Fiktives Blatt" KEIN Fehler 
		if ($debug > 1) {
			echo "\n<p class='dbg'>keine Namensnummern zum Blatt</p>";
			//if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".$sqln."<br>$1=gml(Blatt)= '".$gmlid."'</p>";}
		}
	}
	pg_free_result($resn);
	return $n; 
} // End function eigentuemer

function werteliste ($element, $bezeichnung ,$sqlin) {
	// Eine oder mehrere Entschlüsselungen aus "alkis_wertearten" in eine Zeile ausgeben.
	// Dient dazu, Schlüssel-ARRAYs auflösen ohne die Zeile mehrfach aufzulisten (JOIN)
	// Anwendung: FS-Nachweis Bodenschätzung "Klimastufe + Wasserverhältnisse"
	global $debug;
	$sql="SELECT k, v FROM alkis_wertearten WHERE element = $1 AND bezeichnung = $2 AND k IN (".$sqlin.") ORDER BY k;";
	$v = array($element, $bezeichnung);
	$res = pg_prepare("", $sql);
	$res = pg_execute("", $v);
	if (!$res) {
		echo "\n<p class='err'>Fehler bei Werteliste aus alkis_wertearten.</p>";
		if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = '".$sqlin."'</p>";}
		return;
	}
	$i=0;
	while($row = pg_fetch_array($res)) {
		echo " ".$row["v"];
		$i++;	
	}
	pg_free_result($res);
	if ($i == 0 ) {echo "(kein Treffer)";}
	return;
}

?>